#include <pthread.h>

/*  Nodes */

typedef struct stack_node_t {  
  void *val ;
  struct stack_node_t *next ;
  // Specific
  void *block ; // Pointer to malloc'ed block
} stack_node_t ;


/* Stack proper */
typedef struct {
  stack_node_t *top ;
  pthread_mutex_t *mutex ;
} stack_t ;

stack_t *alloc_stack(int nprocs) ;
void free_stack(stack_t *p) ;

void push(stack_t *p, void *v) ;
void *pop(stack_t *p,int id) ;

inline static void init_heap(void) { } ;
